ServerEvents.recipes(event => {
	// Gate wireless ender power behind improved intelligent grist
	event.recipes.powah.energizing(['#forge:ender_pearls', 'powah:dielectric_casing', '#kubejs:grist/energetic/radiant', '#kubejs:grist/intelligent/improved'], 'powah:ender_core', 50000)

	event.shaped('powah:aerial_pearl', [
		'ABA',
		'BCB', 
		'ABA'
	], {
		'A': 'powah:dielectric_paste',
		'B': '#chipped:iron_bars',
		'C': '#kubejs:grist/intelligent/improved'
	});

	// Dielectric casings are used in nearly every powah recipe, so lets require energetic grist
	event.shaped('powah:dielectric_casing', [
		'ABA',
		'CDC',
		'ABA'
	], {
		'A': global.ingotItem('iron'),
		'B': 'powah:dielectric_rod_horizontal',
		'C': 'powah:dielectric_rod',
		'D': global.ingotItem('copper')
	});

	event.replaceInput(
        {id: 'powah:crafting/capacitor_basic'},
        'minecraft:redstone_block',
        '#kubejs:grist/energetic/basic'
    );
	event.shapeless('powah:capacitor_basic', [
		'3x powah:capacitor_basic_tiny',
		'2x powah:dielectric_paste'
	]);

	event.shapeless('powah:capacitor_basic_tiny', [
		'3x #kubejs:grist/energetic/basic',
		'thermal:rf_coil'
	]);

	event.replaceInput({output: 'powah:thermoelectric_plate'},
		'minecraft:blaze_powder',
		'#kubejs:grist/energetic/basic'
	);
	event.replaceInput({output: 'powah:thermoelectric_plate'},
		'minecraft:redstone',
		'#kubejs:grist/build/basic'
	);

	event.replaceInput({mod: 'powah'},
		'minecraft:quartz',
		Ingredient.of('minecraft:quartz').or('ae2:certus_quartz_crystal')
	);

	event.replaceInput({mod: 'powah'},
		'minecraft:quartz_block',
		Ingredient.of('minecraft:quartz_block').or('ae2:quartz_block')
	);

	// Nitro and spirited require radiant grist
	event.remove({output: 'powah:crystal_nitro'});
	event.recipes.powah.energizing(['3x #kubejs:grist/energetic/radiant/block'], '2x powah:crystal_nitro', 20000000);
	event.remove({output: 'powah:crystal_spirited'});
	event.recipes.powah.energizing(['powah:crystal_niotic', '2x #kubejs:grist/energetic/radiant'], '2x powah:crystal_spirited', 1000000);

	// Niotic and blazing are at the improved tier
	event.remove({output: 'powah:crystal_niotic'});
	event.recipes.powah.energizing(['3x #kubejs:grist/energetic/improved/block'], '2x powah:crystal_niotic', 180000);
	event.remove({output: 'powah:crystal_blazing'});
	event.recipes.powah.energizing(['3x #kubejs:grist/energetic/improved'], '2x powah:crystal_blazing', 90000);

	// Energized steel (aka hardened tier) require basic grist
	event.remove({output: 'powah:steel_energized'});
	event.recipes.powah.energizing(['minecraft:iron', 'minecraft:gold', '3x #kubejs:grist/energetic/basic'], '2x powah:steel_energized', 10000);

	// Dielectric paste can be crafted with basic grist, and scaled up through machines
    event.shapeless('6x powah:dielectric_paste', [
        'kubejs:grist_primordeal_basic',
        'kubejs:grist_energetic_basic',
        'minecraft:redstone',
        'minecraft:clay_ball',
        '#alltheores:ore_hammers'
    ]);
	// TODO: Add create mixing and thermal alloy smelting versions for dialectric paste
	event.recipes.thermal.smelter('24x powah:dielectric_paste', [
		'kubejs:grist_energetic_basic',
		'minecraft:clay_ball',
		'minecraft:redstone'
	]);
	event.recipes.create.mixing('12x powah:dielectric_paste', [
		'kubejs:grist_energetic_basic',
		'minecraft:clay_ball',
		'minecraft:redstone'
	]).heated();
	// TODO: create a crystalizer recipe with destabilized redstone? liquid grist?
});